<!DOCTYPE HTML>
<!-- Index page of the Online Book Store. -->

<html lang=”en”>
<head>
<title>Online Book Store</title>
<link rel="stylesheet" href="styles.css">
<meta charset="UTF-8">
</head>

<body>
    <h1>Online Book Store</h1>
	<div id="wrapper">
		<div id="query">
			<p>Which book category are you interested in?</p>
			<div>
				<input id="search" type="text" onkeyup="loadBooks(event)" />
				<input id="autocomplete" type="text" disabled="disabled" /> 
			</div>
		</div>

		<div id="cart">
			<p>Shopping cart</p>
			<p id="costs">Total costs = 0.0 Euros</p>
			<button onclick="location.href='checkout.html'">Checkout</button>
		</div>
	</div>

	<div id="results">
		<h2>Found items</h2>
		<div id="items">
		<p>No items found so far!</p>
		</div>
	</div>


<script>
	var myObj;
	var restServelet = "http://localhost:8080/onlineStore/rest";
	function loadBooks(e) {
		var array = ["kids", "tech"]
		let search = document.getElementById("search");
		let auto = document.getElementById("autocomplete");

		value = search.value;
		if(value == ""){
			auto.value = "";
			return;
		}
		new_value = value.toLowerCase();
		auto.value = value;
		for(i = 0;i < array.length; i++){
			if(array[i].lastIndexOf(new_value, 0) === 0){
				if(e.keyCode === 39){
					search.value = array[i]
				}
				str_after = array[i].substr(new_value.length, array[i].length);
				new_str = value + str_after
				auto.value = new_str;
				if(e.key == "Enter") {
					var xmlhttp = new XMLHttpRequest();
					var txt = "", x;
					if (this.readyState == 4 && this.status == 200) {
						myObj = JSON.parse(this.responseText);
						txt += "<table_id=\"items-table\">"
						for (x in myObj) {
							txt += "<tr><td>" + myObj[x].shortDescription + "</td><td>"
							+ myObj[x].longDescription + "</td><td>" + myObj[x].cost + "</td><td>"
							+ "<button id=\"" + myObj[x].itemID + "\" onclick=" =\"addToCart(myObj[" + x + "])\">Add to cart</button></tr>";
						}
						txt += "</table>"
						document.getElementById("items").innerHTML = txt;
					}
				};
				xmlhttp.open("GET", restServelet, new_str, true);
				xmlhttp.send();
				search.value = "";
				auto.value = "";
			}
			return;
		}
	}
	function addToCart(item){
		var xmlhttpPost = new XMLHttpRequest();
		xmlhttpPost.onreadystatechange = function() {
			if(this.readyState == 4 && this.status == 204) {
				var xmlhttp = new XMLHttpRequest();
				xmlhttp.onreadystatechange = function () {
					if(this.readyState == 4 && this.status == 200){
						document.getElementById("costs").innerHTML = "Total Costs = "+this.responseText+" euros";
					}
				}
				xmlhttp.open("GET", restServelet + "cart/costs", true);
				xmlhttp.send();
			}
		}
		xmlhttpPost.open("POST", restServelet + "cart",true);
		xmlhttpPost.setRequestHeader("Content-type","application/json");
		var order = [{item, numItems : 1}];
		xmlhttpPost.send(JSON.stringify(order))
	};
</script>


</body>
</html>
